package planet.commonapi.GML;

import planet.commonapi.Id;

/**
 * This interface is used to define constraints on edge selection. Is not a
 * feature included on GML format specifications. 
 * @author Marc Sanchez <marc.sanchez@estudiants.urv.es>
 */
public interface GMLConstraint extends java.io.Serializable {
	/**
	 * This method returns true if a GMLEdgeImpl is compliant according to this GMLConstraint.
	 * @param e GMLEdgeImpl to check.  
	 * @return true if GMLEdgeImpl is compliant according to this constraint
	 */
	public boolean isACompliantEdge(GMLEdge e);
	/**
	 * This method returns true if a Node is compliant according to this GMLConstraint.
	 * @param id Id to check.
	 * @return true if Id is compliant accordint to this constraint.
	 */
	public boolean isACompliantNode(Id id);
	
}
