package planet.simulate;

import planet.util.OrderedList;
import java.util.*;

/**
 * @author Pedro Garca 
 * This class implements the interface IScheduler and manage
 * events to produce to simulated network.
 */
public class Scheduler implements IScheduler, java.io.Serializable {

	private Vector periodic[];
	private int nextAlarm = Globals.ALARMS;
	private OrderedList alarms = null;
	

	public Scheduler(){
	
		periodic = new Vector[100];
		
		
		for (int i=0;i<100;i++){
			periodic[i] = null;
		}
		
	}
	
	public void addEvents(Vector events){
		Iterator it = events.iterator();
		if (events.size()>1){
			Vector e1 = new Vector();
			Event e = (Event) it.next();
			e1.add(e);
			alarms = new OrderedList(e1,e.getTime());
		}
		
		while (it.hasNext()){
			
			Event e = (Event) it.next();
			int time = e.getTime();
			
			if (!alarms.contains(time)){
				Vector list = new Vector();
				list.add(e);
				alarms.insert(new OrderedList(list,time));
			}else {
				Vector list2 = (Vector)alarms.get(time);
				list2.add(e);
			}
		}
		nextAlarm = alarms.value();
	}
	
	


	/**
	 * @see planet.simulate.IScheduler#addPeriodicGenerator(planet.simulate.IEventGenerator, int, int)
	 */
	public void addPeriodicGenerator(
		IEventGenerator gen,
		int repeat,
		int from) {
		//TODO Auto-generated method stub
	}

	/**
	 * @see planet.simulate.IScheduler#removePeriodicGenerator(planet.simulate.IEventGenerator)
	 */
	public void removePeriodicGenerator(IEventGenerator gen) {
		// TODO Auto-generated method stub

	}

	public Vector getEvents(int time){
		Vector events = new Vector();
		Iterator it;
		
		
		if ((nextAlarm!=Globals.ALARMS) && (nextAlarm==time)){

			Vector evts = (Vector)alarms.get(time);
			events.addAll(evts);
			alarms = alarms.pop();
			
			if (alarms==null){
				nextAlarm = Globals.ALARMS;
			}else {
				nextAlarm = alarms.value();
			}
			
		}
		
		
		 
		return events;
	}
	
	public boolean hasNext() {
	  return nextAlarm!=Globals.ALARMS;
	}

}
